leetcode 752. Open the Lock (Python)

752. Open the Lock (Python)

Related Topic

Breadth-First-Search.

Description

You have a lock in front of you with 4 circular wheels. Each wheel has 10 slots: ‘0’, ‘1’, ‘2’, ‘3’, ‘4’, ‘5’, ‘6’, ‘7’, ‘8’, ‘9’. The wheels can rotate freely and wrap around: for example we can turn ‘9’ to be ‘0’, or ‘0’ to be ‘9’. Each move consists of turning one wheel one slot.

The lock initially starts at ‘0000’, a string representing the state of the 4 wheels.

You are given a list of deadends dead ends, meaning if the lock displays any of these codes, the wheels of the lock will stop turning and you will be unable to open it.

Given a target representing the value of the wheels that will unlock the lock, return the minimum total number of turns required to open the lock, or -1 if it is impossible.

Sample I/O

Example 1

Input: deadends = ["0201","0101","0102","1212","2002"], target = "0202"
Output: 6
Explanation:
A sequence of valid moves would be "0000" -> "1000" -> "1100" -> "1200" -> "1201" -> "1202" -> "0202".
Note that a sequence like "0000" -> "0001" -> "0002" -> "0102" -> "0202" would be invalid,
because the wheels of the lock become stuck after the display becomes the dead end "0102".

Example 2

Input: deadends = ["8888"], target = "0009"
Output: 1
Explanation:
We can turn the last wheel in reverse to move from "0000" -> "0009".

Example 3

Input: deadends = ["8887","8889","8878","8898","8788","8988","7888","9888"], target = "8888"
Output: -1
Explanation:
We can't reach the target without getting stuck.

Example 4

Input: deadends = ["0000"], target = "8888"
Output: -1

Note

  1. The length of deadends will be in the range [1, 500].
  2. target will not be in the list deadends.
  3. Every string in deadends and the string target will be a string of 4 digits from the 10,000 possibilities ‘0000’ to ‘9999’.

Methodology

Append the init string and initial step to queue. If the string in dead lock set, continue. If the string is target string return step. Iterate each digit and either plus 1 or minus 1. If the digit is add up to 10 make it become 1. Append the string to the queue if it is not visited and use BFS to traveral the new string again.

Code (BFS)

def openLock(self, deadends: List[str], target: str) -> int:
        dead_set = set(deadends)
        queue = collections.deque()
        queue.append(('0000', 0))
        visited = set('0000')
        
        while queue:
            string, step = queue.popleft()
            
            if string in dead_set:
                continue
            if string == target:
                return step
            for i in range(4):
                num = int(string[i])
                for dx in (-1, 1):
                    num_new = (num + dx) % 10
                    string_new = string[:i] + str(num_new) + string[i+1:]
                    print(string_new)
                    if string_new not in visited:
                        queue.append((string_new, step+1))
                        visited.add(string_new)
        return -1

BigO

We traversal all elements once so total time complexity is O(n)

Search

    Table of Contents